Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.jdbc.meta
Class Discriminator

    java.lang.Object
      org.apache.openjpa.jdbc.meta.Discriminator

All Implemented Interfaces:
  Serializable, DiscriminatorStrategy, Strategy, MetaDataContext, MetaDataModes

    public class Discriminator

extends Object
implements DiscriminatorStrategy, MetaDataContext, MetaDataModes

Handles determining the object class of database records.

Author:
  Abe White
See Also:
  Serialized Form

Field Summary
`static Object` | `NULL` Null discriminator value marker.

Fields inherited from interface org.apache.openjpa.meta.MetaDataModes
`MODE_ALL, MODE_ANN_MAPPING, MODE_MAPPING, MODE_MAPPING_INIT, MODE_META, MODE_NONE, MODE_QUERY`

Constructor Summary
`Discriminator(ClassMapping mapping)` Constructor.

Method Summary
`boolean` | `addClassConditions(Select sel, boolean subs, Joins joins)` Add WHERE conditions to the given select limiting the returned results to our mapping type, possibly including subclasses.
`void` | `clearMapping()` Clear mapping information, including strategy.
`void` | `customDelete(OpenJPAStateManager sm, JDBCStore store)` Override this method to customize flushing this mapping.
`void` | `customInsert(OpenJPAStateManager sm, JDBCStore store)` Override this method to customize flushing this mapping.
`void` | `customUpdate(OpenJPAStateManager sm, JDBCStore store)` Override this method to customize flushing this mapping.
`void` | `delete(OpenJPAStateManager sm, JDBCStore store, RowManager rm)` Set the where values appropriately to delete the proper instance, and set all relations on non-secondary tables as updates.
`String` | `getAlias()` Return the alias of this strategy.
`Class<?>` | `getClass(JDBCStore store, ClassMapping base, Result result)` Return the class for the current result row.
`SQLBuffer` | `getClassConditions(Select sel, Joins joins, ClassMapping base, boolean subs)` Return SQL to limit the classes selected as much as possible to the given base class, and optionally its subclasses.
`ClassMapping` | `getClassMapping()` Return the owning mapping.
`ColumnIO` | `getColumnIO()` I/O information on the discriminator columns.
`Column[]` | `getColumns()` Columns used by this Discriminator.
`Index` | `getIndex()` Index on the Discriminator columns, or null if none.
`int` | `getJavaType()`
`DiscriminatorMappingInfo` | `getMappingInfo()` Raw mapping data.
`MappingRepository` | `getMappingRepository()`
`MetaDataRepository` | `getRepository()` Access metadata repository.
`int` | `getResolve()` Resolve mode.
`DiscriminatorStrategy` | `getStrategy()` The strategy used for class discrimination.
`boolean` | `getSubclassesLoaded()` Whether this Discriminator has loaded subclasses yet.
`Object` | `getValue()` The discriminator value.
`boolean` | `hasClassConditions(ClassMapping base, boolean subs)` Whether any class conditions are necessary.
`void` | `initialize()` Perform caching and other initialization operations.
`void` | `insert(OpenJPAStateManager sm, JDBCStore store, RowManager rm)` Set values for the mapping into the proper rows.
`Boolean` | `isCustomDelete(OpenJPAStateManager sm, JDBCStore store)` Return `Boolean.FALSE` if this mapping does not customize the delete process, `Boolean.TRUE` if it does, or null if it does customize the delete, but also relies on the standard delete method being called.
`Boolean` | `isCustomInsert(OpenJPAStateManager sm, JDBCStore store)` Return `Boolean.FALSE` if this mapping does not customize the insert process, `Boolean.TRUE` if it does, or null if it does customize the insert, but also relies on the standard insert method being called.
`Boolean` | `isCustomUpdate(OpenJPAStateManager sm, JDBCStore store)` Return `Boolean.FALSE` if this mapping does not customize the update process, `Boolean.TRUE` if it does, or null if it does customize the update, but also relies on the standard update method being called.
`void` | `loadSubclasses(JDBCStore store)` Load all subclasses of the owning class mapping into the JVM.
`void` | `map(boolean adapt)` Map the owning mapping using this strategy.
`void` | `refSchemaComponents()` Increment the reference count of used schema components.
`boolean` | `resolve(int mode)` Resolve mapping information.
`boolean` | `select(Select sel, ClassMapping mapping)` Select the data for this Discriminator.
`void` | `setColumnIO(ColumnIO io)` I/O information on the discriminator columns.
`void` | `setColumns(Column[] cols)` Columns used by this Discriminator.
`void` | `setDiscriminator(Discriminator owner)` Set the Discriminator that uses this strategy.
`void` | `setIndex(Index idx)` Index on the Discriminator columns, or null if none.
`void` | `setJavaType(int javaType)`
`void` | `setResolve(int mode)` Resolve mode.
`void` | `setResolve(int mode, boolean on)` Resolve mode.
`void` | `setStrategy(DiscriminatorStrategy strategy, Boolean adapt)` The strategy used for class discrimination.
`void` | `setSubclassesLoaded(boolean loaded)` Whether this Discriminator has loaded subclasses yet.
`void` | `setValue(Object value)` The discriminator value.
`void` | `syncMappingInfo()` Update `MappingInfo` with our current mapping information.
`String` | `toString()`
`void` | `update(OpenJPAStateManager sm, JDBCStore store, RowManager rm)` Set values for the mapping into the proper rows.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### NULL

    public static final Object NULL

  Null discriminator value marker.

Constructor Detail

### Discriminator

    public Discriminator(ClassMapping mapping)

  Constructor. Supply owning mapping.

Method Detail

### getRepository

    public MetaDataRepository getRepository()

  Description copied from interface: `MetaDataContext`
  Access metadata repository.

  Specified by:
    `getRepository` in interface `MetaDataContext`

### getMappingRepository

    public MappingRepository getMappingRepository()

### getClassMapping

    public ClassMapping getClassMapping()

  Return the owning mapping.

### getStrategy

    public DiscriminatorStrategy getStrategy()

  The strategy used for class discrimination.

### setStrategy

    public void setStrategy(DiscriminatorStrategy strategy,
                            Boolean adapt)

  The strategy used for class discrimination. The `adapt` parameter determines whether to adapt when mapping the strategy; use null if the strategy should not be mapped.

### getValue

    public Object getValue()

  The discriminator value.

### setValue

    public void setValue(Object value)

  The discriminator value.

### getMappingInfo

    public DiscriminatorMappingInfo getMappingInfo()

  Raw mapping data.

### getColumns

    public Column[] getColumns()

  Columns used by this Discriminator.

### setColumns

    public void setColumns(Column[] cols)

  Columns used by this Discriminator.

### getColumnIO

    public ColumnIO getColumnIO()

  I/O information on the discriminator columns.

### setColumnIO

    public void setColumnIO(ColumnIO io)

  I/O information on the discriminator columns.

### getIndex

    public Index getIndex()

  Index on the Discriminator columns, or null if none.

### setIndex

    public void setIndex(Index idx)

  Index on the Discriminator columns, or null if none.

### refSchemaComponents

    public void refSchemaComponents()

  Increment the reference count of used schema components.

### clearMapping

    public void clearMapping()

  Clear mapping information, including strategy.

### syncMappingInfo

    public void syncMappingInfo()

  Update `MappingInfo` with our current mapping information.

### getResolve

    public int getResolve()

  Resolve mode.

### setResolve

    public void setResolve(int mode)

  Resolve mode.

### setResolve

    public void setResolve(int mode,
                           boolean on)

  Resolve mode.

### resolve

    public boolean resolve(int mode)

  Resolve mapping information.

### getSubclassesLoaded

    public boolean getSubclassesLoaded()

  Whether this Discriminator has loaded subclasses yet.

### setSubclassesLoaded

    public void setSubclassesLoaded(boolean loaded)

  Whether this Discriminator has loaded subclasses yet.

### addClassConditions

    public boolean addClassConditions(Select sel,
                                      boolean subs,
                                      Joins joins)

  Add WHERE conditions to the given select limiting the returned results to our mapping type, possibly including subclasses.

### getAlias

    public String getAlias()

  Description copied from interface: `Strategy`
  Return the alias of this strategy. For custom strategies, return the full class name.

  Specified by:
    `getAlias` in interface `Strategy`

### map

    public void map(boolean adapt)

  Description copied from interface: `Strategy`
  Map the owning mapping using this strategy.

  Specified by:
    `map` in interface `Strategy`
  Parameters:
    `adapt` - if true, use the owning mapping's raw mapping info to set its ORM data; if false, ORM data will already be set

### initialize

    public void initialize()

  Description copied from interface: `Strategy`
  Perform caching and other initialization operations. This method is called after `Strategy.map(boolean)`, and after all related components have been mapped as well.

  Specified by:
    `initialize` in interface `Strategy`

### insert

    public void insert(OpenJPAStateManager sm,
                       JDBCStore store,
                       RowManager rm)
                throws SQLException

  Description copied from interface: `Strategy`
  Set values for the mapping into the proper rows. For class mappings, this method will be called only after the corresponding method has been called for all fields of this mapping.

  Specified by:
    `insert` in interface `Strategy`
  Throws:
    `SQLException`

### update

    public void update(OpenJPAStateManager sm,
                       JDBCStore store,
                       RowManager rm)
                throws SQLException

  Description copied from interface: `Strategy`
  Set values for the mapping into the proper rows.

  Specified by:
    `update` in interface `Strategy`
  Throws:
    `SQLException`
  See Also:
    `Strategy.insert(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore, org.apache.openjpa.jdbc.sql.RowManager)`

### delete

    public void delete(OpenJPAStateManager sm,
                       JDBCStore store,
                       RowManager rm)
                throws SQLException

  Description copied from interface: `Strategy`
  Set the where values appropriately to delete the proper instance, and set all relations on non-secondary tables as updates. This allows foreign key analysis.

  Specified by:
    `delete` in interface `Strategy`
  Throws:
    `SQLException`
  See Also:
    `Strategy.insert(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore, org.apache.openjpa.jdbc.sql.RowManager)`

### isCustomInsert

    public Boolean isCustomInsert(OpenJPAStateManager sm,
                                  JDBCStore store)

  Description copied from interface: `Strategy`
  Return `Boolean.FALSE` if this mapping does not customize the insert process, `Boolean.TRUE` if it does, or null if it does customize the insert, but also relies on the standard insert method being called. Implement the `Strategy.customInsert(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore)` method to implement the custom insertion behavior.

  Specified by:
    `isCustomInsert` in interface `Strategy`

### isCustomUpdate

    public Boolean isCustomUpdate(OpenJPAStateManager sm,
                                  JDBCStore store)

  Description copied from interface: `Strategy`
  Return `Boolean.FALSE` if this mapping does not customize the update process, `Boolean.TRUE` if it does, or null if it does customize the update, but also relies on the standard update method being called. Implement the `Strategy.customUpdate(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore)` method to override the default update behavior.

  Specified by:
    `isCustomUpdate` in interface `Strategy`

### isCustomDelete

    public Boolean isCustomDelete(OpenJPAStateManager sm,
                                  JDBCStore store)

  Description copied from interface: `Strategy`
  Return `Boolean.FALSE` if this mapping does not customize the delete process, `Boolean.TRUE` if it does, or null if it does customize the delete, but also relies on the standard delete method being called. Implement the `Strategy.customDelete(org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore)` method to override the default deletion behavior.

  Specified by:
    `isCustomDelete` in interface `Strategy`

### customInsert

    public void customInsert(OpenJPAStateManager sm,
                             JDBCStore store)
                      throws SQLException

  Description copied from interface: `Strategy`
  Override this method to customize flushing this mapping. For classes, this method must also flush all fields. For fields, this method is called after the owning object is inserted, so if this field is in a row with other fields, that row will already exist.

  Specified by:
    `customInsert` in interface `Strategy`
  Throws:
    `SQLException`

### customUpdate

    public void customUpdate(OpenJPAStateManager sm,
                             JDBCStore store)
                      throws SQLException

  Description copied from interface: `Strategy`
  Override this method to customize flushing this mapping. For classes, this method must also flush all fields.

  Specified by:
    `customUpdate` in interface `Strategy`
  Throws:
    `SQLException`

### customDelete

    public void customDelete(OpenJPAStateManager sm,
                             JDBCStore store)
                      throws SQLException

  Description copied from interface: `Strategy`
  Override this method to customize flushing this mapping. For classes, this method must also flush all fields. For fields, this method will be called after the owning object is deleted.

  Specified by:
    `customDelete` in interface `Strategy`
  Throws:
    `SQLException`

### setDiscriminator

    public void setDiscriminator(Discriminator owner)

  Description copied from interface: `DiscriminatorStrategy`
  Set the Discriminator that uses this strategy. This will be called before use.

  Specified by:
    `setDiscriminator` in interface `DiscriminatorStrategy`

### select

    public boolean select(Select sel,
                          ClassMapping mapping)

  Description copied from interface: `DiscriminatorStrategy`
  Select the data for this Discriminator.

  Specified by:
    `select` in interface `DiscriminatorStrategy`
    `mapping` - the known base class being selected; this may not be the base class in the inheritance hierarchy
  Returns:
    true if anything was selected; false otherwise

### loadSubclasses

    public void loadSubclasses(JDBCStore store)
                        throws SQLException,
                               ClassNotFoundException

  Description copied from interface: `DiscriminatorStrategy`
  Load all subclasses of the owning class mapping into the JVM.

  Specified by:
    `loadSubclasses` in interface `DiscriminatorStrategy`
  Throws:
    `SQLException`
    `ClassNotFoundException`

### getClass

    public Class<?> getClass(JDBCStore store,
                             ClassMapping base,
                             Result result)
                      throws SQLException,
                             ClassNotFoundException

  Description copied from interface: `DiscriminatorStrategy`
  Return the class for the current result row.

  Specified by:
    `getClass` in interface `DiscriminatorStrategy`
  Throws:
    `SQLException`
    `ClassNotFoundException`

### hasClassConditions

    public boolean hasClassConditions(ClassMapping base,
                                      boolean subs)

  Description copied from interface: `DiscriminatorStrategy`
  Whether any class conditions are necessary.

  Specified by:
    `hasClassConditions` in interface `DiscriminatorStrategy`
  See Also:
    `DiscriminatorStrategy.getClassConditions(org.apache.openjpa.jdbc.sql.Select, org.apache.openjpa.jdbc.sql.Joins, org.apache.openjpa.jdbc.meta.ClassMapping, boolean)`

### getClassConditions

    public SQLBuffer getClassConditions(Select sel,
                                        Joins joins,
                                        ClassMapping base,
                                        boolean subs)

  Description copied from interface: `DiscriminatorStrategy`
  Return SQL to limit the classes selected as much as possible to the given base class, and optionally its subclasses. The select and joins instances are supplied in order to get column aliases.

  Specified by:
    `getClassConditions` in interface `DiscriminatorStrategy`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### setJavaType

    public void setJavaType(int javaType)

### getJavaType

    public int getJavaType()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 Apache Software Foundation. All Rights Reserved.